> ## Documentation Index
> Fetch the complete documentation index at: https://v0.x-docs.novu.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Update integration as primary

> Update an integration as **primary** by its unique key identifier **integrationId**. 
    This API will set the integration as primary for that channel in the current environment. 
    Primary integration is used to deliver notification for sms and email channels in the workflow. 
    Only integration metadata is returned, credentials field is returned as an empty object.

<Warning>
  Enter your API key in the `Authorization` field like the example shown below:

  E.g `ApiKey 18d2e625f05d80e`
</Warning>

<RequestExample>
  ```javascript Node.js theme={null}
  import { Novu } from '@novu/node';  

  const novu = new Novu('<NOVU_API_KEY>');

  await novu.integrations.setIntegrationAsPrimary("integrationId")
  ```

  ```php PHP theme={null}
  <?php

  $url = 'https://api.novu.co/v1/integrations/:integrationId/set-primary';
  $data = array(
    [options]
  );
  $options = array(
    "http" => array(
    "header"  => "Content-type: application/json",
    "header"  => "Authorization: ApiKey REPLACE_WITH_API_KEY",
    "method"  => "POST",
    "content" => json_encode($data)
    )
  );
  $context  = stream_context_create($options);
  $result = file_get_contents($url, false, $context);

  if ($result === FALSE) { /* Handle error */ }

  echo $result;
      
  ```

  ```ruby Ruby theme={null}
  require 'net/http'
  require 'uri'

  uri = URI.parse('https://api.novu.co/v1/integrations/:integrationId/set-primary')
  http = Net::HTTP.new(uri.host, uri.port)
  request = Net::HTTP::Post.new(uri.request_uri)

  request.body = '{
    [options]
  }'
  request.content_type = 'application/json'
  request.add_field('Authorization', 'ApiKey REPLACE_WITH_API_KEY')


  response = http.request(request)

  puts response.body
      
  ```

  ```go Go theme={null}
  package main

  import (
    "fmt"
    "net/http"
    "encoding/json"
  )

  func main() {
    url := "https://api.novu.co/v1/integrations/:integrationId/set-primary"
    data := map[string]string{
      [options]
    }
    jsonValue, _ := json.Marshal(data)
    req, _ := http.NewRequest("POST", url, bytes.NewBuffer(jsonValue))
    req.Header.Set("Content-Type", "application/json")
    req.Header.Set("Authorization", "ApiKey REPLACE_WITH_API_KEY")

    defer resp.Body.Close()
    body, _ := ioutil.ReadAll(resp.Body)
    fmt.Println(string(body))
  }
  ```

  ```python Python theme={null}
  import requests

  response = requests.post('https://api.novu.co/v1/integrations/:integrationId/set-primary')

  print(response.json())
      
  ```
</RequestExample>

<ResponseExample>
  ```json Response theme={null}
  {
    "_id": "string",
    "_environmentId": "string",
    "_organizationId": "string",
    "name": "string",
    "identifier": "string",
    "providerId": "string",
    "channel": "in_app",
    "credentials": {
      "apiKey": "string",
      "user": "string",
      "secretKey": "string",
      "domain": "string",
      "password": "string",
      "host": "string",
      "port": "string",
      "secure": true,
      "region": "string",
      "accountSid": "string",
      "messageProfileId": "string",
      "token": "string",
      "from": "string",
      "senderName": "string",
      "projectName": "string",
      "applicationId": "string",
      "clientId": "string",
      "requireTls": true,
      "ignoreTls": true,
      "tlsOptions": {},
      "baseUrl": "string",
      "webhookUrl": "string",
      "redirectUrl": "string",
      "hmac": true,
      "serviceAccount": "string",
      "ipPoolName": "string"
    },
    "active": true,
    "deleted": true,
    "deletedAt": "string",
    "deletedBy": "string",
    "primary": true
  }
  ```
</ResponseExample>


## OpenAPI

````yaml post /v1/integrations/{integrationId}/set-primary
openapi: 3.0.0
info:
  title: Novu API
  description: >-
    Novu REST API. Please see https://docs.novu.co/api-reference for more
    details.
  version: '1.0'
  contact:
    name: Novu Support
    url: https://discord.gg/novu
    email: support@novu.co
  termsOfService: https://novu.co/terms
  license:
    name: MIT
    url: https://opensource.org/license/mit
servers:
  - url: https://api.novu.co
  - url: https://eu.api.novu.co
security: []
tags:
  - name: Events
    description: >-
      Events represent a change in state of a subscriber. They are used to
      trigger workflows, and enable you to send notifications to subscribers
      based on their actions.
    externalDocs:
      url: https://docs.novu.co/workflows
  - name: Subscribers
    description: >-
      A subscriber in Novu represents someone who should receive a message. A
      subscriber’s profile information contains important attributes about the
      subscriber that will be used in messages (name, email). The subscriber
      object can contain other key-value pairs that can be used to further
      personalize your messages.
    externalDocs:
      url: https://docs.novu.co/subscribers/subscribers
  - name: Topics
    description: >-
      Topics are a way to group subscribers together so that they can be
      notified of events at once. A topic is identified by a custom key. This
      can be helpful for things like sending out marketing emails or notifying
      users of new features. Topics can also be used to send notifications to
      the subscribers who have been grouped together based on their interests,
      location, activities and much more.
    externalDocs:
      url: https://docs.novu.co/subscribers/topics
  - name: Notification
    description: >-
      A notification conveys information from source to recipient, triggered by
      a workflow acting as a message blueprint. Notifications can be individual
      or bundled as digest for user-friendliness.
    externalDocs:
      url: https://docs.novu.co/getting-started/introduction
  - name: Integrations
    description: >-
      With the help of the Integration Store, you can easily integrate your
      favorite delivery provider. During the runtime of the API, the
      Integrations Store is responsible for storing the configurations of all
      the providers.
    externalDocs:
      url: https://docs.novu.co/channels-and-providers/integration-store
  - name: Layouts
    description: >-
      Novu allows the creation of layouts - a specific HTML design or structure
      to wrap content of email notifications. Layouts can be manipulated and
      assigned to new or existing workflows within the Novu platform, allowing
      users to create, manage, and assign these layouts to workflows, so they
      can be reused to structure the appearance of notifications sent through
      the platform.
    externalDocs:
      url: https://docs.novu.co/content-creation-design/layouts
  - name: Workflows
    description: >-
      All notifications are sent via a workflow. Each workflow acts as a
      container for the logic and blueprint that are associated with a type of
      notification in your system.
    externalDocs:
      url: https://docs.novu.co/workflows
  - name: Notification Templates
    description: >-
      Deprecated. Use Workflows (/workflows) instead, which provide the same
      functionality under a new name.
  - name: Workflow groups
    description: Workflow groups are used to organize workflows into logical groups.
  - name: Changes
    description: >-
      Changes represent a change in state of an environment. They are analagous
      to a pending pull request in git, enabling you to test changes before they
      are applied to your environment and atomically apply them when you are
      ready.
    externalDocs:
      url: >-
        https://docs.novu.co/platform/environments#promoting-pending-changes-to-production
  - name: Environments
    description: >-
      Novu uses the concept of environments to ensure logical separation of your
      data and configuration. This means that subscribers, and preferences
      created in one environment are never accessible to another.
    externalDocs:
      url: https://docs.novu.co/platform/environments
  - name: Inbound Parse
    description: >-
      Inbound Webhook is a feature that allows processing of incoming emails for
      a domain or subdomain. The feature parses the contents of the email and
      POSTs the information to a specified URL in a multipart/form-data format.
    externalDocs:
      url: https://docs.novu.co/platform/inbound-parse-webhook
  - name: Feeds
    description: >-
      Novu provides a notification activity feed that monitors every outgoing
      message associated with its relevant metadata. This can be used to monitor
      activity and discover potential issues with a specific provider or a
      channel type.
    externalDocs:
      url: https://docs.novu.co/activity-feed
  - name: Tenants
    description: >-
      A tenant represents a group of users. As a developer, when your apps have
      organizations, they are referred to as tenants. Tenants in Novu provides
      the ability to tailor specific notification experiences to users of
      different groups or organizations.
    externalDocs:
      url: https://docs.novu.co/tenants
  - name: Messages
    description: >-
      A message in Novu represents a notification delivered to a recipient on a
      particular channel. Messages contain information about the request that
      triggered its delivery, a view of the data sent to the recipient, and a
      timeline of its lifecycle events. Learn more about messages.
    externalDocs:
      url: https://docs.novu.co/workflows/messages
  - name: Organizations
    description: >-
      An organization serves as a separate entity within your Novu account. Each
      organization you create has its own separate integration store, workflows,
      subscribers, and API keys. This separation of resources allows you to
      manage multi-tenant environments and separate domains within a single
      account.
    externalDocs:
      url: https://docs.novu.co/platform/organizations
  - name: Execution Details
    description: >-
      Execution details are used to track the execution of a workflow. They
      provided detailed information on the execution of a workflow, including
      the status of each step, the input and output of each step, and the
      overall status of the execution.
    externalDocs:
      url: https://docs.novu.co/activity-feed
externalDocs:
  description: Novu Documentation
  url: https://docs.novu.co
paths:
  /v1/integrations/{integrationId}/set-primary:
    post:
      tags:
        - Integrations
      summary: Set integration as primary
      operationId: IntegrationsController_setIntegrationAsPrimary
      parameters:
        - name: integrationId
          required: true
          in: path
          schema:
            type: string
      responses:
        '200':
          description: Ok
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/IntegrationResponseDto'
        '201':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/IntegrationResponseDto'
        '404':
          description: >-
            The integration with the integrationId provided does not exist in
            the database.
        '409':
          description: >-
            The request could not be completed due to a conflict with the
            current state of the target resource.
          content:
            application/json:
              schema:
                type: string
                example: >-
                  Request with key 3909d656-d4fe-4e80-ba86-90d3861afcd7 is
                  currently being processed. Please retry after 1 second
        '429':
          description: 'The client has sent too many requests in a given amount of time. '
          content:
            application/json:
              schema:
                type: string
                example: API rate limit exceeded
        '503':
          description: >-
            The server is currently unable to handle the request due to a
            temporary overload or scheduled maintenance, which will likely be
            alleviated after some delay.
          content:
            application/json:
              schema:
                type: string
                example: Please wait some time, then try again.
      security:
        - api-key: []
      x-codeSamples:
        - lang: typescript
          label: IntegrationsController_setIntegrationAsPrimary
          source: |-
            import { Novu } from "@novu/api";

            const novu = new Novu({
              apiKey: "<YOUR_API_KEY_HERE>",
            });

            async function run() {
              const result = await novu.integrations.setAsPrimary("<value>");

              // Handle the result
              console.log(result)
            }

            run();
components:
  schemas:
    IntegrationResponseDto:
      type: object
      properties:
        _id:
          type: string
        _environmentId:
          type: string
        _organizationId:
          type: string
        name:
          type: string
        identifier:
          type: string
        providerId:
          type: string
        channel:
          type: string
          enum:
            - in_app
            - email
            - sms
            - chat
            - push
        credentials:
          $ref: '#/components/schemas/CredentialsDto'
        active:
          type: boolean
        deleted:
          type: boolean
        deletedAt:
          type: string
        deletedBy:
          type: string
        primary:
          type: boolean
        conditions:
          type: array
          items:
            $ref: '#/components/schemas/StepFilter'
      required:
        - _environmentId
        - _organizationId
        - name
        - identifier
        - providerId
        - channel
        - credentials
        - active
        - deleted
        - deletedAt
        - deletedBy
        - primary
    CredentialsDto:
      type: object
      properties:
        apiKey:
          type: string
        user:
          type: string
        secretKey:
          type: string
        domain:
          type: string
        password:
          type: string
        host:
          type: string
        port:
          type: string
        secure:
          type: boolean
        region:
          type: string
        accountSid:
          type: string
        messageProfileId:
          type: string
        token:
          type: string
        from:
          type: string
        senderName:
          type: string
        projectName:
          type: string
        applicationId:
          type: string
        clientId:
          type: string
        requireTls:
          type: boolean
        ignoreTls:
          type: boolean
        tlsOptions:
          type: object
        baseUrl:
          type: string
        webhookUrl:
          type: string
        redirectUrl:
          type: string
        hmac:
          type: boolean
        serviceAccount:
          type: string
        ipPoolName:
          type: string
        apiKeyRequestHeader:
          type: string
        secretKeyRequestHeader:
          type: string
        idPath:
          type: string
        datePath:
          type: string
        apiToken:
          type: string
        authenticateByToken:
          type: boolean
        authenticationTokenKey:
          type: string
        instanceId:
          type: string
        alertUid:
          type: string
        title:
          type: string
        imageUrl:
          type: string
        state:
          type: string
        externalLink:
          type: string
        channelId:
          type: string
        phoneNumberIdentification:
          type: string
    StepFilter:
      type: object
      properties:
        isNegated:
          type: boolean
        type:
          type: string
          enum:
            - BOOLEAN
            - TEXT
            - DATE
            - NUMBER
            - STATEMENT
            - LIST
            - MULTI_LIST
            - GROUP
        value:
          type: string
          enum:
            - AND
            - OR
        children:
          type: array
          items:
            $ref: '#/components/schemas/FieldFilterPart'
      required:
        - isNegated
        - type
        - value
        - children
    FieldFilterPart:
      type: object
      properties:
        field:
          type: string
        value:
          type: string
        operator:
          type: string
          enum:
            - LARGER
            - SMALLER
            - LARGER_EQUAL
            - SMALLER_EQUAL
            - EQUAL
            - NOT_EQUAL
            - ALL_IN
            - ANY_IN
            - NOT_IN
            - BETWEEN
            - NOT_BETWEEN
            - LIKE
            - NOT_LIKE
            - IN
        'on':
          type: string
          enum:
            - subscriber
            - payload
      required:
        - field
        - value
        - operator
        - 'on'
  securitySchemes:
    api-key:
      type: apiKey
      in: header
      name: Authorization
      description: >-
        API key authentication. Allowed headers-- "Authorization: ApiKey
        <api_key>".

````